import config

PROJECT_NAME = 'T0Mon'

REPACK_RECONSTRUCTION_QUEUED = 5
REPACK_RECONSTRUCTION_DISABLED = 6

RECONSTRUCTED_ALCASKIM_QUEUED = 6
RECONSTRUCTED_ALCASKIM_DISABLED = 7

RECONSTRUCTED_RECO = "RECO"
RECONSTRUCTED_ALCASKIM = "ALCARECO"

class TABLES:
    PREFIX = ""

    MERGE_JOBS = PREFIX + 'merge_job_def'
    RECO_JOBS = PREFIX + 'promptreco_job_def'
    REPACK_JOBS = PREFIX + 'repack_job_def'
    ALCA_JOBS = PREFIX + 'alcaskim_job_def'

    RUN = PREFIX + 'run'
    RUN_STATUS = PREFIX + 'run_status'
    STREAMER = PREFIX + 'streamer'
    STREAM = PREFIX + 'stream'
    REPACKED = PREFIX + 'repacked'
    REPACK_STREAMER_ASSOC = PREFIX + 'repack_streamer_assoc'
    MERGE_JOB_REPACK_ASSOC = PREFIX + 'merge_job_repack_assoc'
    MERGE_JOB_RECO_ASSOC = PREFIX + 'merge_job_reco_assoc'
    RECO_JOB_REPACK_ASSOC = PREFIX + 'promptreco_job_repack_assoc'
    ALCA_JOB_RECO_ASSOC = PREFIX + 'alcaskim_job_reco_assoc'
    JOB_DATASET_STREAMER_ASSOC = PREFIX + 'job_streamer_dataset_assoc'
    REPACK_STREAMER_ASSOC = PREFIX + 'repack_streamer_assoc'
    JOB_STATUS = PREFIX + 'job_status'
    PRIMARY_DATASET = PREFIX + 'primary_dataset'
    EXPORT_STATUS = PREFIX + 'export_status'
    REPACKED_STATUS = PREFIX + 'repacked_status'
    RECONSTRUCTED = PREFIX + 'reconstructed'
    RECONSTRUCTED_STATUS = PREFIX + 'reconstructed_status'
    REPACKED_RECO_PARENTAGE = PREFIX + 'repacked_reco_parentage'
    RECO_MERGE_PARENTAGE = PREFIX + 'reco_merge_parentage'
    ALCASKIM_MERGE_PARENTAGE = PREFIX + 'alcaskim_merge_parentage'
    REPACKED_MERGE_PARENTAGE = PREFIX + 'repacked_merge_parentage'
    EXPORT_STATUS = PREFIX + 'export_status'
    VERSION = PREFIX + 'version'

    REPACK_CONFIG = PREFIX + 'repack_config'
    RECO_CONFIG = PREFIX + 'reco_config'
    CMSSW_VERSION = PREFIX + 'cmssw_version'
    ALCA_CONFIG = PREFIX + 'alca_config'

    WMBS_FILE_DETAILS = PREFIX + 'wmbs_file_details'
    WMBS_FILE_DATASET_PATH_ASSOC = PREFIX + 'wmbs_file_dataset_path_assoc'
    DATASET_PATH = PREFIX + 'dataset_path'
    DATA_TIER = PREFIX + 'data_tier'
    DATASET_RUN_STREAM_ASSOC = PREFIX + 'dataset_run_stream_assoc'
    PROCESSED_DATASET = PREFIX + 'processed_dataset'
    WMBS_FILE_RUNLUMI_MAP = PREFIX + 'wmbs_file_runlumi_map'
    WMBS_SUB_FILES_COMPLETE = PREFIX + 'wmbs_sub_files_complete'
    WMBS_SUB_FILES_ACQUIRED = PREFIX + 'wmbs_sub_files_acquired'
    WMBS_SUBSCRIPTION = PREFIX + 'wmbs_subscription'
    WMBS_SUBS_TYPE = PREFIX + 'wmbs_subs_type'
    WMBS_FILESET = PREFIX + 'wmbs_fileset'
    WMBS_FILESET_FILES = PREFIX + 'wmbs_fileset_files' 
    WMBS_FILE_PARENT = PREFIX + 'wmbs_file_parent'
    WMBS_WORKFLOW = PREFIX + 'wmbs_workflow'

    WMBS_JOB = PREFIX + 'wmbs_job'
    WMBS_JOBGROUP = PREFIX + 'wmbs_jobgroup'
    WMBS_GROUP_JOB_COMPLETE = PREFIX + 'wmbs_group_job_complete'
    WMBS_GROUP_JOB_ACQUIRED = PREFIX + 'wmbs_group_job_acquired'
    WMBS_GROUP_JOB_FAILED = PREFIX + 'wmbs_group_job_failed'
    WMBS_JOB_ASSOC = PREFIX + 'wmbs_job_assoc'


JOB_NEW, JOB_USED, JOB_SUCCESS, JOB_FAILURE = range(1, 5)

JOB_STATUS = {
    "ACQUIRED": "acquired",
    "COMPLETE": "successful",
    "FAILED": "failed",
}

JOB_TYPE = {
    "RAW": {
             "": "Repack merge",
             "NOT": "Reconstruction"
           },
    "RECO": { 
              "": "Reco merge",
              "NOT": "AlcaSkim"
            },
    "ALCARECO": { 
                  "": "AlcaSkim merge",
                  "NOT": "ERROR"
                }
}

JOB_STATUS_REPACKED = {
    JOB_NEW : "new",
    JOB_USED: "used",
    JOB_SUCCESS: "successful",
    JOB_FAILURE: "failed",
}

DEV_SERVER = 'vocms13'
